from .devpropdef import DEFINE_DEVPROPKEY

# DEVPKEY_NAME
# Common DEVPKEY used to retrieve the display name for an object.
DEVPKEY_NAME = DEFINE_DEVPROPKEY(
    0xB725F130, 0x47EF, 0x101A, 0xA5, 0xF1, 0x02, 0x60, 0x8C, 0x9E, 0xEB, 0xAC, 10
)  # DEVPROP_TYPE_STRING

# Device properties
# These DEVPKEYs correspond to the SetupAPI SPDRP_XXX device properties.
DEVPKEY_Device_DeviceDesc = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 2
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_HardwareIds = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 3
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_CompatibleIds = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 4
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_Service = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 6
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_Class = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 9
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_ClassGuid = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 10
)  # DEVPROP_TYPE_GUID
DEVPKEY_Device_Driver = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 11
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_ConfigFlags = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 12
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_Manufacturer = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 13
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_FriendlyName = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 14
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_LocationInfo = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 15
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_PDOName = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 16
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_Capabilities = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 17
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_UINumber = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 18
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_UpperFilters = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 19
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_LowerFilters = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 20
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_BusTypeGuid = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 21
)  # DEVPROP_TYPE_GUID
DEVPKEY_Device_LegacyBusType = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 22
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_BusNumber = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 23
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_EnumeratorName = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 24
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_Security = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 25
)  # DEVPROP_TYPE_SECURITY_DESCRIPTOR
DEVPKEY_Device_SecuritySDS = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 26
)  # DEVPROP_TYPE_SECURITY_DESCRIPTOR_STRING
DEVPKEY_Device_DevType = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 27
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_Exclusive = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 28
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_Device_Characteristics = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 29
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_Address = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 30
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_UINumberDescFormat = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 31
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_PowerData = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 32
)  # DEVPROP_TYPE_BINARY
DEVPKEY_Device_RemovalPolicy = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 33
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_RemovalPolicyDefault = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 34
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_RemovalPolicyOverride = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 35
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_InstallState = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 36
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_LocationPaths = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 37
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_BaseContainerId = DEFINE_DEVPROPKEY(
    0xA45C254E, 0xDF1C, 0x4EFD, 0x80, 0x20, 0x67, 0xD1, 0x46, 0xA8, 0x50, 0xE0, 38
)  # DEVPROP_TYPE_GUID

# Device and Device Interface property
# Common DEVPKEY used to retrieve the device instance id associated with devices and device interfaces.
DEVPKEY_Device_InstanceId = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 256
)  # DEVPROP_TYPE_STRING

# Device properties
# These DEVPKEYs correspond to a device's status and problem code.
DEVPKEY_Device_DevNodeStatus = DEFINE_DEVPROPKEY(
    0x4340A6C5, 0x93FA, 0x4706, 0x97, 0x2C, 0x7B, 0x64, 0x80, 0x08, 0xA5, 0xA7, 2
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_ProblemCode = DEFINE_DEVPROPKEY(
    0x4340A6C5, 0x93FA, 0x4706, 0x97, 0x2C, 0x7B, 0x64, 0x80, 0x08, 0xA5, 0xA7, 3
)  # DEVPROP_TYPE_UINT32

# Device properties
# These DEVPKEYs correspond to a device's relations.
DEVPKEY_Device_EjectionRelations = DEFINE_DEVPROPKEY(
    0x4340A6C5, 0x93FA, 0x4706, 0x97, 0x2C, 0x7B, 0x64, 0x80, 0x08, 0xA5, 0xA7, 4
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_RemovalRelations = DEFINE_DEVPROPKEY(
    0x4340A6C5, 0x93FA, 0x4706, 0x97, 0x2C, 0x7B, 0x64, 0x80, 0x08, 0xA5, 0xA7, 5
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_PowerRelations = DEFINE_DEVPROPKEY(
    0x4340A6C5, 0x93FA, 0x4706, 0x97, 0x2C, 0x7B, 0x64, 0x80, 0x08, 0xA5, 0xA7, 6
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_BusRelations = DEFINE_DEVPROPKEY(
    0x4340A6C5, 0x93FA, 0x4706, 0x97, 0x2C, 0x7B, 0x64, 0x80, 0x08, 0xA5, 0xA7, 7
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_Parent = DEFINE_DEVPROPKEY(
    0x4340A6C5, 0x93FA, 0x4706, 0x97, 0x2C, 0x7B, 0x64, 0x80, 0x08, 0xA5, 0xA7, 8
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_Children = DEFINE_DEVPROPKEY(
    0x4340A6C5, 0x93FA, 0x4706, 0x97, 0x2C, 0x7B, 0x64, 0x80, 0x08, 0xA5, 0xA7, 9
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_Siblings = DEFINE_DEVPROPKEY(
    0x4340A6C5, 0x93FA, 0x4706, 0x97, 0x2C, 0x7B, 0x64, 0x80, 0x08, 0xA5, 0xA7, 10
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_TransportRelations = DEFINE_DEVPROPKEY(
    0x4340A6C5, 0x93FA, 0x4706, 0x97, 0x2C, 0x7B, 0x64, 0x80, 0x08, 0xA5, 0xA7, 11
)  # DEVPROP_TYPE_STRING_LIST

# Device property
# This DEVPKEY corresponds to a the status code that resulted in a device to be in a problem state.
DEVPKEY_Device_ProblemStatus = DEFINE_DEVPROPKEY(
    0x4340A6C5, 0x93FA, 0x4706, 0x97, 0x2C, 0x7B, 0x64, 0x80, 0x08, 0xA5, 0xA7, 12
)  # DEVPROP_TYPE_NTSTATUS

# Device properties
# These DEVPKEYs are set for the corresponding types of root-enumerated devices.
DEVPKEY_Device_Reported = DEFINE_DEVPROPKEY(
    0x80497100, 0x8C73, 0x48B9, 0xAA, 0xD9, 0xCE, 0x38, 0x7E, 0x19, 0xC5, 0x6E, 2
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_Device_Legacy = DEFINE_DEVPROPKEY(
    0x80497100, 0x8C73, 0x48B9, 0xAA, 0xD9, 0xCE, 0x38, 0x7E, 0x19, 0xC5, 0x6E, 3
)  # DEVPROP_TYPE_BOOLEAN


# Device Container Id
DEVPKEY_Device_ContainerId = DEFINE_DEVPROPKEY(
    0x8C7ED206, 0x3F8A, 0x4827, 0xB3, 0xAB, 0xAE, 0x9E, 0x1F, 0xAE, 0xFC, 0x6C, 2
)  # DEVPROP_TYPE_GUID
DEVPKEY_Device_InLocalMachineContainer = DEFINE_DEVPROPKEY(
    0x8C7ED206, 0x3F8A, 0x4827, 0xB3, 0xAB, 0xAE, 0x9E, 0x1F, 0xAE, 0xFC, 0x6C, 4
)  # DEVPROP_TYPE_BOOLEAN


# Device property
# This DEVPKEY correspond to a device's model.
DEVPKEY_Device_Model = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 39
)  # DEVPROP_TYPE_STRING

# Device Experience related Keys
DEVPKEY_Device_ModelId = DEFINE_DEVPROPKEY(
    0x80D81EA6, 0x7473, 0x4B0C, 0x82, 0x16, 0xEF, 0xC1, 0x1A, 0x2C, 0x4C, 0x8B, 2
)  # DEVPROP_TYPE_GUID
DEVPKEY_Device_FriendlyNameAttributes = DEFINE_DEVPROPKEY(
    0x80D81EA6, 0x7473, 0x4B0C, 0x82, 0x16, 0xEF, 0xC1, 0x1A, 0x2C, 0x4C, 0x8B, 3
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_ManufacturerAttributes = DEFINE_DEVPROPKEY(
    0x80D81EA6, 0x7473, 0x4B0C, 0x82, 0x16, 0xEF, 0xC1, 0x1A, 0x2C, 0x4C, 0x8B, 4
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_PresenceNotForDevice = DEFINE_DEVPROPKEY(
    0x80D81EA6, 0x7473, 0x4B0C, 0x82, 0x16, 0xEF, 0xC1, 0x1A, 0x2C, 0x4C, 0x8B, 5
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_Device_SignalStrength = DEFINE_DEVPROPKEY(
    0x80D81EA6, 0x7473, 0x4B0C, 0x82, 0x16, 0xEF, 0xC1, 0x1A, 0x2C, 0x4C, 0x8B, 6
)  # DEVPROP_TYPE_INT32
DEVPKEY_Device_IsAssociateableByUserAction = DEFINE_DEVPROPKEY(
    0x80D81EA6, 0x7473, 0x4B0C, 0x82, 0x16, 0xEF, 0xC1, 0x1A, 0x2C, 0x4C, 0x8B, 7
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_Device_ShowInUninstallUI = DEFINE_DEVPROPKEY(
    0x80D81EA6, 0x7473, 0x4B0C, 0x82, 0x16, 0xEF, 0xC1, 0x1A, 0x2C, 0x4C, 0x8B, 8
)  # DEVPROP_TYPE_BOOLEAN

# Hardware Support App (HSA) properties
DEVPKEY_Device_CompanionApps = DEFINE_DEVPROPKEY(
    0x6A742654, 0xD0B2, 0x4420, 0xA5, 0x23, 0xE0, 0x68, 0x35, 0x2A, 0xC1, 0xDF, 2
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_PrimaryCompanionApp = DEFINE_DEVPROPKEY(
    0x6A742654, 0xD0B2, 0x4420, 0xA5, 0x23, 0xE0, 0x68, 0x35, 0x2A, 0xC1, 0xDF, 3
)  # DEVPROP_TYPE_STRING

# Other Device properties
# define DEVPKEY_Numa_Proximity_Domain  DEVPKEY_Device_Numa_Proximity_Domain
DEVPKEY_Device_Numa_Proximity_Domain = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 1
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_DHP_Rebalance_Policy = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 2
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_Numa_Node = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 3
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_BusReportedDeviceDesc = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 4
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_IsPresent = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 5
)  # DEVPROP_TYPE_BOOL
DEVPKEY_Device_HasProblem = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 6
)  # DEVPROP_TYPE_BOOL
DEVPKEY_Device_ConfigurationId = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 7
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_ReportedDeviceIdsHash = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 8
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_PhysicalDeviceLocation = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 9
)  # DEVPROP_TYPE_BINARY
DEVPKEY_Device_BiosDeviceName = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 10
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_DriverProblemDesc = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 11
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_DebuggerSafe = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 12
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_PostInstallInProgress = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 13
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_Device_Stack = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 14
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_ExtendedConfigurationIds = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 15
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_IsRebootRequired = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 16
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_Device_FirmwareDate = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 17
)  # DEVPROP_TYPE_FILETIME
DEVPKEY_Device_FirmwareVersion = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 18
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_FirmwareRevision = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 19
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_DependencyProviders = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 20
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_DependencyDependents = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 21
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_SoftRestartSupported = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 22
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_Device_ExtendedAddress = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 23
)  # DEVPROP_TYPE_UINT64
DEVPKEY_Device_AssignedToGuest = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 24
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_Device_CreatorProcessId = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 25
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_FirmwareVendor = DEFINE_DEVPROPKEY(
    0x540B947E, 0x8B40, 0x45BC, 0xA8, 0xA2, 0x6A, 0x0B, 0x89, 0x4C, 0xBD, 0xA2, 26
)  # DEVPROP_TYPE_STRING

DEVPKEY_Device_SessionId = DEFINE_DEVPROPKEY(
    0x83DA6326, 0x97A6, 0x4088, 0x94, 0x53, 0xA1, 0x92, 0x3F, 0x57, 0x3B, 0x29, 6
)  # DEVPROP_TYPE_UINT32

# Device activity timestamp properties
DEVPKEY_Device_InstallDate = DEFINE_DEVPROPKEY(
    0x83DA6326, 0x97A6, 0x4088, 0x94, 0x53, 0xA1, 0x92, 0x3F, 0x57, 0x3B, 0x29, 100
)  # DEVPROP_TYPE_FILETIME
DEVPKEY_Device_FirstInstallDate = DEFINE_DEVPROPKEY(
    0x83DA6326, 0x97A6, 0x4088, 0x94, 0x53, 0xA1, 0x92, 0x3F, 0x57, 0x3B, 0x29, 101
)  # DEVPROP_TYPE_FILETIME
DEVPKEY_Device_LastArrivalDate = DEFINE_DEVPROPKEY(
    0x83DA6326, 0x97A6, 0x4088, 0x94, 0x53, 0xA1, 0x92, 0x3F, 0x57, 0x3B, 0x29, 102
)  # DEVPROP_TYPE_FILETIME
DEVPKEY_Device_LastRemovalDate = DEFINE_DEVPROPKEY(
    0x83DA6326, 0x97A6, 0x4088, 0x94, 0x53, 0xA1, 0x92, 0x3F, 0x57, 0x3B, 0x29, 103
)  # DEVPROP_TYPE_FILETIME


# Device driver properties
DEVPKEY_Device_DriverDate = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 2
)  # DEVPROP_TYPE_FILETIME
DEVPKEY_Device_DriverVersion = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 3
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_DriverDesc = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 4
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_DriverInfPath = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 5
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_DriverInfSection = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 6
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_DriverInfSectionExt = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 7
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_MatchingDeviceId = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 8
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_DriverProvider = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 9
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_DriverPropPageProvider = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 10
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_DriverCoInstallers = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 11
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_Device_ResourcePickerTags = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 12
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_ResourcePickerExceptions = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 13
)  # DEVPROP_TYPE_STRING
DEVPKEY_Device_DriverRank = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 14
)  # DEVPROP_TYPE_UINT32
DEVPKEY_Device_DriverLogoLevel = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 15
)  # DEVPROP_TYPE_UINT32

# Device properties
# These DEVPKEYs may be set by the driver package installed for a device.
DEVPKEY_Device_NoConnectSound = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 17
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_Device_GenericDriverInstalled = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 18
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_Device_AdditionalSoftwareRequested = DEFINE_DEVPROPKEY(
    0xA8B865DD, 0x2E3D, 0x4094, 0xAD, 0x97, 0xE5, 0x93, 0xA7, 0xC, 0x75, 0xD6, 19
)  # DEVPROP_TYPE_BOOLEAN

# Device safe-removal properties
DEVPKEY_Device_SafeRemovalRequired = DEFINE_DEVPROPKEY(
    0xAFD97640, 0x86A3, 0x4210, 0xB6, 0x7C, 0x28, 0x9C, 0x41, 0xAA, 0xBE, 0x55, 2
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_Device_SafeRemovalRequiredOverride = DEFINE_DEVPROPKEY(
    0xAFD97640, 0x86A3, 0x4210, 0xB6, 0x7C, 0x28, 0x9C, 0x41, 0xAA, 0xBE, 0x55, 3
)  # DEVPROP_TYPE_BOOLEAN


# Device properties
# These DEVPKEYs may be set by the driver package installed for a device.
DEVPKEY_DrvPkg_Model = DEFINE_DEVPROPKEY(
    0xCF73BB51, 0x3ABF, 0x44A2, 0x85, 0xE0, 0x9A, 0x3D, 0xC7, 0xA1, 0x21, 0x32, 2
)  # DEVPROP_TYPE_STRING
DEVPKEY_DrvPkg_VendorWebSite = DEFINE_DEVPROPKEY(
    0xCF73BB51, 0x3ABF, 0x44A2, 0x85, 0xE0, 0x9A, 0x3D, 0xC7, 0xA1, 0x21, 0x32, 3
)  # DEVPROP_TYPE_STRING
DEVPKEY_DrvPkg_DetailedDescription = DEFINE_DEVPROPKEY(
    0xCF73BB51, 0x3ABF, 0x44A2, 0x85, 0xE0, 0x9A, 0x3D, 0xC7, 0xA1, 0x21, 0x32, 4
)  # DEVPROP_TYPE_STRING
DEVPKEY_DrvPkg_DocumentationLink = DEFINE_DEVPROPKEY(
    0xCF73BB51, 0x3ABF, 0x44A2, 0x85, 0xE0, 0x9A, 0x3D, 0xC7, 0xA1, 0x21, 0x32, 5
)  # DEVPROP_TYPE_STRING
DEVPKEY_DrvPkg_Icon = DEFINE_DEVPROPKEY(
    0xCF73BB51, 0x3ABF, 0x44A2, 0x85, 0xE0, 0x9A, 0x3D, 0xC7, 0xA1, 0x21, 0x32, 6
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_DrvPkg_BrandingIcon = DEFINE_DEVPROPKEY(
    0xCF73BB51, 0x3ABF, 0x44A2, 0x85, 0xE0, 0x9A, 0x3D, 0xC7, 0xA1, 0x21, 0x32, 7
)  # DEVPROP_TYPE_STRING_LIST


# Device setup class properties
# These DEVPKEYs correspond to the SetupAPI SPCRP_XXX setup class properties.
DEVPKEY_DeviceClass_UpperFilters = DEFINE_DEVPROPKEY(
    0x4321918B, 0xF69E, 0x470D, 0xA5, 0xDE, 0x4D, 0x88, 0xC7, 0x5A, 0xD2, 0x4B, 19
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_DeviceClass_LowerFilters = DEFINE_DEVPROPKEY(
    0x4321918B, 0xF69E, 0x470D, 0xA5, 0xDE, 0x4D, 0x88, 0xC7, 0x5A, 0xD2, 0x4B, 20
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_DeviceClass_Security = DEFINE_DEVPROPKEY(
    0x4321918B, 0xF69E, 0x470D, 0xA5, 0xDE, 0x4D, 0x88, 0xC7, 0x5A, 0xD2, 0x4B, 25
)  # DEVPROP_TYPE_SECURITY_DESCRIPTOR
DEVPKEY_DeviceClass_SecuritySDS = DEFINE_DEVPROPKEY(
    0x4321918B, 0xF69E, 0x470D, 0xA5, 0xDE, 0x4D, 0x88, 0xC7, 0x5A, 0xD2, 0x4B, 26
)  # DEVPROP_TYPE_SECURITY_DESCRIPTOR_STRING
DEVPKEY_DeviceClass_DevType = DEFINE_DEVPROPKEY(
    0x4321918B, 0xF69E, 0x470D, 0xA5, 0xDE, 0x4D, 0x88, 0xC7, 0x5A, 0xD2, 0x4B, 27
)  # DEVPROP_TYPE_UINT32
DEVPKEY_DeviceClass_Exclusive = DEFINE_DEVPROPKEY(
    0x4321918B, 0xF69E, 0x470D, 0xA5, 0xDE, 0x4D, 0x88, 0xC7, 0x5A, 0xD2, 0x4B, 28
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceClass_Characteristics = DEFINE_DEVPROPKEY(
    0x4321918B, 0xF69E, 0x470D, 0xA5, 0xDE, 0x4D, 0x88, 0xC7, 0x5A, 0xD2, 0x4B, 29
)  # DEVPROP_TYPE_UINT32

# Device setup class properties
DEVPKEY_DeviceClass_Name = DEFINE_DEVPROPKEY(
    0x259ABFFC, 0x50A7, 0x47CE, 0xAF, 0x8, 0x68, 0xC9, 0xA7, 0xD7, 0x33, 0x66, 2
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceClass_ClassName = DEFINE_DEVPROPKEY(
    0x259ABFFC, 0x50A7, 0x47CE, 0xAF, 0x8, 0x68, 0xC9, 0xA7, 0xD7, 0x33, 0x66, 3
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceClass_Icon = DEFINE_DEVPROPKEY(
    0x259ABFFC, 0x50A7, 0x47CE, 0xAF, 0x8, 0x68, 0xC9, 0xA7, 0xD7, 0x33, 0x66, 4
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceClass_ClassInstaller = DEFINE_DEVPROPKEY(
    0x259ABFFC, 0x50A7, 0x47CE, 0xAF, 0x8, 0x68, 0xC9, 0xA7, 0xD7, 0x33, 0x66, 5
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceClass_PropPageProvider = DEFINE_DEVPROPKEY(
    0x259ABFFC, 0x50A7, 0x47CE, 0xAF, 0x8, 0x68, 0xC9, 0xA7, 0xD7, 0x33, 0x66, 6
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceClass_NoInstallClass = DEFINE_DEVPROPKEY(
    0x259ABFFC, 0x50A7, 0x47CE, 0xAF, 0x8, 0x68, 0xC9, 0xA7, 0xD7, 0x33, 0x66, 7
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceClass_NoDisplayClass = DEFINE_DEVPROPKEY(
    0x259ABFFC, 0x50A7, 0x47CE, 0xAF, 0x8, 0x68, 0xC9, 0xA7, 0xD7, 0x33, 0x66, 8
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceClass_SilentInstall = DEFINE_DEVPROPKEY(
    0x259ABFFC, 0x50A7, 0x47CE, 0xAF, 0x8, 0x68, 0xC9, 0xA7, 0xD7, 0x33, 0x66, 9
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceClass_NoUseClass = DEFINE_DEVPROPKEY(
    0x259ABFFC, 0x50A7, 0x47CE, 0xAF, 0x8, 0x68, 0xC9, 0xA7, 0xD7, 0x33, 0x66, 10
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceClass_DefaultService = DEFINE_DEVPROPKEY(
    0x259ABFFC, 0x50A7, 0x47CE, 0xAF, 0x8, 0x68, 0xC9, 0xA7, 0xD7, 0x33, 0x66, 11
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceClass_IconPath = DEFINE_DEVPROPKEY(
    0x259ABFFC, 0x50A7, 0x47CE, 0xAF, 0x8, 0x68, 0xC9, 0xA7, 0xD7, 0x33, 0x66, 12
)  # DEVPROP_TYPE_STRING_LIST

# Other Device setup class properties
DEVPKEY_DeviceClass_DHPRebalanceOptOut = DEFINE_DEVPROPKEY(
    0xD14D3EF3, 0x66CF, 0x4BA2, 0x9D, 0x38, 0x0D, 0xDB, 0x37, 0xAB, 0x47, 0x01, 2
)  # DEVPROP_TYPE_BOOLEAN

DEVPKEY_DeviceClass_ClassCoInstallers = DEFINE_DEVPROPKEY(
    0x713D1703, 0xA2E2, 0x49F5, 0x92, 0x14, 0x56, 0x47, 0x2E, 0xF3, 0xDA, 0x5C, 2
)  # DEVPROP_TYPE_STRING_LIST

# Device interface properties
DEVPKEY_DeviceInterface_FriendlyName = DEFINE_DEVPROPKEY(
    0x026E516E, 0xB814, 0x414B, 0x83, 0xCD, 0x85, 0x6D, 0x6F, 0xEF, 0x48, 0x22, 2
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceInterface_Enabled = DEFINE_DEVPROPKEY(
    0x026E516E, 0xB814, 0x414B, 0x83, 0xCD, 0x85, 0x6D, 0x6F, 0xEF, 0x48, 0x22, 3
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceInterface_ClassGuid = DEFINE_DEVPROPKEY(
    0x026E516E, 0xB814, 0x414B, 0x83, 0xCD, 0x85, 0x6D, 0x6F, 0xEF, 0x48, 0x22, 4
)  # DEVPROP_TYPE_GUID
DEVPKEY_DeviceInterface_ReferenceString = DEFINE_DEVPROPKEY(
    0x026E516E, 0xB814, 0x414B, 0x83, 0xCD, 0x85, 0x6D, 0x6F, 0xEF, 0x48, 0x22, 5
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceInterface_Restricted = DEFINE_DEVPROPKEY(
    0x026E516E, 0xB814, 0x414B, 0x83, 0xCD, 0x85, 0x6D, 0x6F, 0xEF, 0x48, 0x22, 6
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceInterface_UnrestrictedAppCapabilities = DEFINE_DEVPROPKEY(
    0x026E516E, 0xB814, 0x414B, 0x83, 0xCD, 0x85, 0x6D, 0x6F, 0xEF, 0x48, 0x22, 8
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_DeviceInterface_SchematicName = DEFINE_DEVPROPKEY(
    0x026E516E, 0xB814, 0x414B, 0x83, 0xCD, 0x85, 0x6D, 0x6F, 0xEF, 0x48, 0x22, 9
)  # DEVPROP_TYPE_STRING

# Device interface class properties
DEVPKEY_DeviceInterfaceClass_DefaultInterface = DEFINE_DEVPROPKEY(
    0x14C83A99, 0x0B3F, 0x44B7, 0xBE, 0x4C, 0xA1, 0x78, 0xD3, 0x99, 0x05, 0x64, 2
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceInterfaceClass_Name = DEFINE_DEVPROPKEY(
    0x14C83A99, 0x0B3F, 0x44B7, 0xBE, 0x4C, 0xA1, 0x78, 0xD3, 0x99, 0x05, 0x64, 3
)  # DEVPROP_TYPE_STRING

# Device Container Properties
DEVPKEY_DeviceContainer_Address = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 51
)  # DEVPROP_TYPE_STRING | DEVPROP_TYPE_STRING_LIST
DEVPKEY_DeviceContainer_DiscoveryMethod = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 52
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_DeviceContainer_IsEncrypted = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 53
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_IsAuthenticated = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 54
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_IsConnected = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 55
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_IsPaired = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 56
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_Icon = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 57
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceContainer_Version = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 65
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceContainer_Last_Seen = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 66
)  # DEVPROP_TYPE_FILETIME
DEVPKEY_DeviceContainer_Last_Connected = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 67
)  # DEVPROP_TYPE_FILETIME
DEVPKEY_DeviceContainer_IsShowInDisconnectedState = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 68
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_IsLocalMachine = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 70
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_MetadataPath = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 71
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceContainer_IsMetadataSearchInProgress = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 72
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_MetadataChecksum = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 73
)  # DEVPROP_TYPE_BINARY
DEVPKEY_DeviceContainer_IsNotInterestingForDisplay = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 74
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_LaunchDeviceStageOnDeviceConnect = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 76
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_LaunchDeviceStageFromExplorer = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 77
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_BaselineExperienceId = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 78
)  # DEVPROP_TYPE_GUID
DEVPKEY_DeviceContainer_IsDeviceUniquelyIdentifiable = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 79
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_AssociationArray = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 80
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_DeviceContainer_DeviceDescription1 = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 81
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceContainer_DeviceDescription2 = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 82
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceContainer_HasProblem = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 83
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_IsSharedDevice = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 84
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_IsNetworkDevice = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 85
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_IsDefaultDevice = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 86
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_MetadataCabinet = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 87
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceContainer_RequiresPairingElevation = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 88
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_ExperienceId = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 89
)  # DEVPROP_TYPE_GUID
DEVPKEY_DeviceContainer_Category = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 90
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_DeviceContainer_Category_Desc_Singular = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 91
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_DeviceContainer_Category_Desc_Plural = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 92
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_DeviceContainer_Category_Icon = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 93
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceContainer_CategoryGroup_Desc = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 94
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_DeviceContainer_CategoryGroup_Icon = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 95
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceContainer_PrimaryCategory = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 97
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceContainer_UnpairUninstall = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 98
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_RequiresUninstallElevation = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 99
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_DeviceFunctionSubRank = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 100
)  # DEVPROP_TYPE_UINT32
DEVPKEY_DeviceContainer_AlwaysShowDeviceAsConnected = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 101
)  # DEVPROP_TYPE_BOOLEAN
DEVPKEY_DeviceContainer_ConfigFlags = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 105
)  # DEVPROP_TYPE_UINT32
DEVPKEY_DeviceContainer_PrivilegedPackageFamilyNames = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 106
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_DeviceContainer_CustomPrivilegedPackageFamilyNames = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 107
)  # DEVPROP_TYPE_STRING_LIST
DEVPKEY_DeviceContainer_IsRebootRequired = DEFINE_DEVPROPKEY(
    0x78C34FC8, 0x104A, 0x4ACA, 0x9E, 0xA4, 0x52, 0x4D, 0x52, 0x99, 0x6E, 0x57, 108
)  # DEVPROP_TYPE_BOOLEAN

DEVPKEY_DeviceContainer_FriendlyName = DEFINE_DEVPROPKEY(
    0x656A3BB3, 0xECC0, 0x43FD, 0x84, 0x77, 0x4A, 0xE0, 0x40, 0x4A, 0x96, 0xCD, 12288
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceContainer_Manufacturer = DEFINE_DEVPROPKEY(
    0x656A3BB3, 0xECC0, 0x43FD, 0x84, 0x77, 0x4A, 0xE0, 0x40, 0x4A, 0x96, 0xCD, 8192
)  # DEVPROP_TYPE_STRING
DEVPKEY_DeviceContainer_ModelName = DEFINE_DEVPROPKEY(
    0x656A3BB3, 0xECC0, 0x43FD, 0x84, 0x77, 0x4A, 0xE0, 0x40, 0x4A, 0x96, 0xCD, 8194
)  # DEVPROP_TYPE_STRING (localizable)
DEVPKEY_DeviceContainer_ModelNumber = DEFINE_DEVPROPKEY(
    0x656A3BB3, 0xECC0, 0x43FD, 0x84, 0x77, 0x4A, 0xE0, 0x40, 0x4A, 0x96, 0xCD, 8195
)  # DEVPROP_TYPE_STRING

DEVPKEY_DeviceContainer_InstallInProgress = DEFINE_DEVPROPKEY(
    0x83DA6326, 0x97A6, 0x4088, 0x94, 0x53, 0xA1, 0x92, 0x3F, 0x57, 0x3B, 0x29, 9
)  # DEVPROP_TYPE_BOOLEAN

# DeviceContainer properties that can be set on a devnode.
# These used to be defined as DeviceDisplay
DEVPKEY_DeviceDisplay_DiscoveryMethod = DEVPKEY_DeviceContainer_DiscoveryMethod
DEVPKEY_DeviceDisplay_IsShowInDisconnectedState = DEVPKEY_DeviceContainer_IsShowInDisconnectedState
DEVPKEY_DeviceDisplay_IsNotInterestingForDisplay = DEVPKEY_DeviceContainer_IsNotInterestingForDisplay
DEVPKEY_DeviceDisplay_IsNetworkDevice = DEVPKEY_DeviceContainer_IsNetworkDevice
DEVPKEY_DeviceDisplay_Category = DEVPKEY_DeviceContainer_Category
DEVPKEY_DeviceDisplay_UnpairUninstall = DEVPKEY_DeviceContainer_UnpairUninstall
DEVPKEY_DeviceDisplay_RequiresUninstallElevation = DEVPKEY_DeviceContainer_RequiresUninstallElevation
DEVPKEY_DeviceDisplay_AlwaysShowDeviceAsConnected = DEVPKEY_DeviceContainer_AlwaysShowDeviceAsConnected


# DevQuery properties
DEVPKEY_DevQuery_ObjectType = DEFINE_DEVPROPKEY(
    0x13673F42, 0xA3D6, 0x49F6, 0xB4, 0xDA, 0xAE, 0x46, 0xE0, 0xC5, 0x23, 0x7C, 2
)  # DEVPROP_TYPE_UINT32
