from ctypes import c_ubyte

from ..shared.guiddef import GUID


def DEFINE_KNOWN_FOLDER(l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8):  # noqa: E741
    return GUID(l, w1, w2, (c_ubyte * 8)(b1, b2, b3, b4, b5, b6, b7, b8))


FOLDERID_NetworkFolder = DEFINE_KNOWN_FOLDER(0xD20BEEC4, 0x5CA8, 0x4905, 0xAE, 0x3B, 0xBF, 0x25, 0x1E, 0xA0, 0x9B, 0x53)
FOLDERID_ComputerFolder = DEFINE_KNOWN_FOLDER(
    0x0AC0837C, 0xBBF8, 0x452A, 0x85, 0x0D, 0x79, 0xD0, 0x8E, 0x66, 0x7C, 0xA7
)
FOLDERID_InternetFolder = DEFINE_KNOWN_FOLDER(
    0x4D9F7874, 0x4E0C, 0x4904, 0x96, 0x7B, 0x40, 0xB0, 0xD2, 0x0C, 0x3E, 0x4B
)
FOLDERID_ControlPanelFolder = DEFINE_KNOWN_FOLDER(
    0x82A74AEB, 0xAEB4, 0x465C, 0xA0, 0x14, 0xD0, 0x97, 0xEE, 0x34, 0x6D, 0x63
)
FOLDERID_PrintersFolder = DEFINE_KNOWN_FOLDER(
    0x76FC4E2D, 0xD6AD, 0x4519, 0xA6, 0x63, 0x37, 0xBD, 0x56, 0x06, 0x81, 0x85
)
FOLDERID_SyncManagerFolder = DEFINE_KNOWN_FOLDER(
    0x43668BF8, 0xC14E, 0x49B2, 0x97, 0xC9, 0x74, 0x77, 0x84, 0xD7, 0x84, 0xB7
)
FOLDERID_SyncSetupFolder = DEFINE_KNOWN_FOLDER(
    0xF214138, 0xB1D3, 0x4A90, 0xBB, 0xA9, 0x27, 0xCB, 0xC0, 0xC5, 0x38, 0x9A
)
FOLDERID_ConflictFolder = DEFINE_KNOWN_FOLDER(
    0x4BFEFB45, 0x347D, 0x4006, 0xA5, 0xBE, 0xAC, 0x0C, 0xB0, 0x56, 0x71, 0x92
)
FOLDERID_SyncResultsFolder = DEFINE_KNOWN_FOLDER(
    0x289A9A43, 0xBE44, 0x4057, 0xA4, 0x1B, 0x58, 0x7A, 0x76, 0xD7, 0xE7, 0xF9
)
FOLDERID_RecycleBinFolder = DEFINE_KNOWN_FOLDER(
    0xB7534046, 0x3ECB, 0x4C18, 0xBE, 0x4E, 0x64, 0xCD, 0x4C, 0xB7, 0xD6, 0xAC
)
FOLDERID_ConnectionsFolder = DEFINE_KNOWN_FOLDER(
    0x6F0CD92B, 0x2E97, 0x45D1, 0x88, 0xFF, 0xB0, 0xD1, 0x86, 0xB8, 0xDE, 0xDD
)
FOLDERID_Fonts = DEFINE_KNOWN_FOLDER(0xFD228CB7, 0xAE11, 0x4AE3, 0x86, 0x4C, 0x16, 0xF3, 0x91, 0x0A, 0xB8, 0xFE)
FOLDERID_Desktop = DEFINE_KNOWN_FOLDER(0xB4BFCC3A, 0xDB2C, 0x424C, 0xB0, 0x29, 0x7F, 0xE9, 0x9A, 0x87, 0xC6, 0x41)
FOLDERID_Startup = DEFINE_KNOWN_FOLDER(0xB97D20BB, 0xF46A, 0x4C97, 0xBA, 0x10, 0x5E, 0x36, 0x08, 0x43, 0x08, 0x54)
FOLDERID_Programs = DEFINE_KNOWN_FOLDER(0xA77F5D77, 0x2E2B, 0x44C3, 0xA6, 0xA2, 0xAB, 0xA6, 0x01, 0x05, 0x4A, 0x51)
FOLDERID_StartMenu = DEFINE_KNOWN_FOLDER(0x625B53C3, 0xAB48, 0x4EC1, 0xBA, 0x1F, 0xA1, 0xEF, 0x41, 0x46, 0xFC, 0x19)
FOLDERID_Recent = DEFINE_KNOWN_FOLDER(0xAE50C081, 0xEBD2, 0x438A, 0x86, 0x55, 0x8A, 0x09, 0x2E, 0x34, 0x98, 0x7A)
FOLDERID_SendTo = DEFINE_KNOWN_FOLDER(0x8983036C, 0x27C0, 0x404B, 0x8F, 0x08, 0x10, 0x2D, 0x10, 0xDC, 0xFD, 0x74)
FOLDERID_Documents = DEFINE_KNOWN_FOLDER(0xFDD39AD0, 0x238F, 0x46AF, 0xAD, 0xB4, 0x6C, 0x85, 0x48, 0x03, 0x69, 0xC7)
FOLDERID_Favorites = DEFINE_KNOWN_FOLDER(0x1777F761, 0x68AD, 0x4D8A, 0x87, 0xBD, 0x30, 0xB7, 0x59, 0xFA, 0x33, 0xDD)
FOLDERID_NetHood = DEFINE_KNOWN_FOLDER(0xC5ABBF53, 0xE17F, 0x4121, 0x89, 0x00, 0x86, 0x62, 0x6F, 0xC2, 0xC9, 0x73)
FOLDERID_PrintHood = DEFINE_KNOWN_FOLDER(0x9274BD8D, 0xCFD1, 0x41C3, 0xB3, 0x5E, 0xB1, 0x3F, 0x55, 0xA7, 0x58, 0xF4)
FOLDERID_Templates = DEFINE_KNOWN_FOLDER(0xA63293E8, 0x664E, 0x48DB, 0xA0, 0x79, 0xDF, 0x75, 0x9E, 0x05, 0x09, 0xF7)
FOLDERID_CommonStartup = DEFINE_KNOWN_FOLDER(0x82A5EA35, 0xD9CD, 0x47C5, 0x96, 0x29, 0xE1, 0x5D, 0x2F, 0x71, 0x4E, 0x6E)
FOLDERID_CommonPrograms = DEFINE_KNOWN_FOLDER(
    0x0139D44E, 0x6AFE, 0x49F2, 0x86, 0x90, 0x3D, 0xAF, 0xCA, 0xE6, 0xFF, 0xB8
)
FOLDERID_CommonStartMenu = DEFINE_KNOWN_FOLDER(
    0xA4115719, 0xD62E, 0x491D, 0xAA, 0x7C, 0xE7, 0x4B, 0x8B, 0xE3, 0xB0, 0x67
)
FOLDERID_PublicDesktop = DEFINE_KNOWN_FOLDER(0xC4AA340D, 0xF20F, 0x4863, 0xAF, 0xEF, 0xF8, 0x7E, 0xF2, 0xE6, 0xBA, 0x25)
FOLDERID_ProgramData = DEFINE_KNOWN_FOLDER(0x62AB5D82, 0xFDC1, 0x4DC3, 0xA9, 0xDD, 0x07, 0x0D, 0x1D, 0x49, 0x5D, 0x97)
FOLDERID_CommonTemplates = DEFINE_KNOWN_FOLDER(
    0xB94237E7, 0x57AC, 0x4347, 0x91, 0x51, 0xB0, 0x8C, 0x6C, 0x32, 0xD1, 0xF7
)
FOLDERID_PublicDocuments = DEFINE_KNOWN_FOLDER(
    0xED4824AF, 0xDCE4, 0x45A8, 0x81, 0xE2, 0xFC, 0x79, 0x65, 0x08, 0x36, 0x34
)
FOLDERID_RoamingAppData = DEFINE_KNOWN_FOLDER(
    0x3EB685DB, 0x65F9, 0x4CF6, 0xA0, 0x3A, 0xE3, 0xEF, 0x65, 0x72, 0x9F, 0x3D
)
FOLDERID_LocalAppData = DEFINE_KNOWN_FOLDER(0xF1B32785, 0x6FBA, 0x4FCF, 0x9D, 0x55, 0x7B, 0x8E, 0x7F, 0x15, 0x70, 0x91)
FOLDERID_LocalAppDataLow = DEFINE_KNOWN_FOLDER(
    0xA520A1A4, 0x1780, 0x4FF6, 0xBD, 0x18, 0x16, 0x73, 0x43, 0xC5, 0xAF, 0x16
)
FOLDERID_InternetCache = DEFINE_KNOWN_FOLDER(0x352481E8, 0x33BE, 0x4251, 0xBA, 0x85, 0x60, 0x07, 0xCA, 0xED, 0xCF, 0x9D)
FOLDERID_Cookies = DEFINE_KNOWN_FOLDER(0x2B0F765D, 0xC0E9, 0x4171, 0x90, 0x8E, 0x08, 0xA6, 0x11, 0xB8, 0x4F, 0xF6)
FOLDERID_History = DEFINE_KNOWN_FOLDER(0xD9DC8A3B, 0xB784, 0x432E, 0xA7, 0x81, 0x5A, 0x11, 0x30, 0xA7, 0x59, 0x63)
FOLDERID_System = DEFINE_KNOWN_FOLDER(0x1AC14E77, 0x02E7, 0x4E5D, 0xB7, 0x44, 0x2E, 0xB1, 0xAE, 0x51, 0x98, 0xB7)
FOLDERID_SystemX86 = DEFINE_KNOWN_FOLDER(0xD65231B0, 0xB2F1, 0x4857, 0xA4, 0xCE, 0xA8, 0xE7, 0xC6, 0xEA, 0x7D, 0x27)
FOLDERID_Windows = DEFINE_KNOWN_FOLDER(0xF38BF404, 0x1D43, 0x42F2, 0x93, 0x05, 0x67, 0xDE, 0x0B, 0x28, 0xFC, 0x23)
FOLDERID_Profile = DEFINE_KNOWN_FOLDER(0x5E6C858F, 0x0E22, 0x4760, 0x9A, 0xFE, 0xEA, 0x33, 0x17, 0xB6, 0x71, 0x73)
FOLDERID_Pictures = DEFINE_KNOWN_FOLDER(0x33E28130, 0x4E1E, 0x4676, 0x83, 0x5A, 0x98, 0x39, 0x5C, 0x3B, 0xC3, 0xBB)
FOLDERID_ProgramFilesX86 = DEFINE_KNOWN_FOLDER(
    0x7C5A40EF, 0xA0FB, 0x4BFC, 0x87, 0x4A, 0xC0, 0xF2, 0xE0, 0xB9, 0xFA, 0x8E
)
FOLDERID_ProgramFilesCommonX86 = DEFINE_KNOWN_FOLDER(
    0xDE974D24, 0xD9C6, 0x4D3E, 0xBF, 0x91, 0xF4, 0x45, 0x51, 0x20, 0xB9, 0x17
)
FOLDERID_ProgramFilesX64 = DEFINE_KNOWN_FOLDER(
    0x6D809377, 0x6AF0, 0x444B, 0x89, 0x57, 0xA3, 0x77, 0x3F, 0x02, 0x20, 0x0E
)
FOLDERID_ProgramFilesCommonX64 = DEFINE_KNOWN_FOLDER(
    0x6365D5A7, 0xF0D, 0x45E5, 0x87, 0xF6, 0xD, 0xA5, 0x6B, 0x6A, 0x4F, 0x7D
)
FOLDERID_ProgramFiles = DEFINE_KNOWN_FOLDER(0x905E63B6, 0xC1BF, 0x494E, 0xB2, 0x9C, 0x65, 0xB7, 0x32, 0xD3, 0xD2, 0x1A)
FOLDERID_ProgramFilesCommon = DEFINE_KNOWN_FOLDER(
    0xF7F1ED05, 0x9F6D, 0x47A2, 0xAA, 0xAE, 0x29, 0xD3, 0x17, 0xC6, 0xF0, 0x66
)
FOLDERID_UserProgramFiles = DEFINE_KNOWN_FOLDER(
    0x5CD7AEE2, 0x2219, 0x4A67, 0xB8, 0x5D, 0x6C, 0x9C, 0xE1, 0x56, 0x60, 0xCB
)
FOLDERID_UserProgramFilesCommon = DEFINE_KNOWN_FOLDER(
    0xBCBD3057, 0xCA5C, 0x4622, 0xB4, 0x2D, 0xBC, 0x56, 0xDB, 0x0A, 0xE5, 0x16
)
FOLDERID_AdminTools = DEFINE_KNOWN_FOLDER(0x724EF170, 0xA42D, 0x4FEF, 0x9F, 0x26, 0xB6, 0x0E, 0x84, 0x6F, 0xBA, 0x4F)
FOLDERID_CommonAdminTools = DEFINE_KNOWN_FOLDER(
    0xD0384E7D, 0xBAC3, 0x4797, 0x8F, 0x14, 0xCB, 0xA2, 0x29, 0xB3, 0x92, 0xB5
)
FOLDERID_Music = DEFINE_KNOWN_FOLDER(0x4BD8D571, 0x6D19, 0x48D3, 0xBE, 0x97, 0x42, 0x22, 0x20, 0x08, 0x0E, 0x43)
FOLDERID_Videos = DEFINE_KNOWN_FOLDER(0x18989B1D, 0x99B5, 0x455B, 0x84, 0x1C, 0xAB, 0x7C, 0x74, 0xE4, 0xDD, 0xFC)
FOLDERID_Ringtones = DEFINE_KNOWN_FOLDER(0xC870044B, 0xF49E, 0x4126, 0xA9, 0xC3, 0xB5, 0x2A, 0x1F, 0xF4, 0x11, 0xE8)
FOLDERID_PublicPictures = DEFINE_KNOWN_FOLDER(
    0xB6EBFB86, 0x6907, 0x413C, 0x9A, 0xF7, 0x4F, 0xC2, 0xAB, 0xF0, 0x7C, 0xC5
)
FOLDERID_PublicMusic = DEFINE_KNOWN_FOLDER(0x3214FAB5, 0x9757, 0x4298, 0xBB, 0x61, 0x92, 0xA9, 0xDE, 0xAA, 0x44, 0xFF)
FOLDERID_PublicVideos = DEFINE_KNOWN_FOLDER(0x2400183A, 0x6185, 0x49FB, 0xA2, 0xD8, 0x4A, 0x39, 0x2A, 0x60, 0x2B, 0xA3)
FOLDERID_PublicRingtones = DEFINE_KNOWN_FOLDER(
    0xE555AB60, 0x153B, 0x4D17, 0x9F, 0x04, 0xA5, 0xFE, 0x99, 0xFC, 0x15, 0xEC
)
FOLDERID_ResourceDir = DEFINE_KNOWN_FOLDER(0x8AD10C31, 0x2ADB, 0x4296, 0xA8, 0xF7, 0xE4, 0x70, 0x12, 0x32, 0xC9, 0x72)
FOLDERID_LocalizedResourcesDir = DEFINE_KNOWN_FOLDER(
    0x2A00375E, 0x224C, 0x49DE, 0xB8, 0xD1, 0x44, 0x0D, 0xF7, 0xEF, 0x3D, 0xDC
)
FOLDERID_CommonOEMLinks = DEFINE_KNOWN_FOLDER(
    0xC1BAE2D0, 0x10DF, 0x4334, 0xBE, 0xDD, 0x7A, 0xA2, 0x0B, 0x22, 0x7A, 0x9D
)
FOLDERID_CDBurning = DEFINE_KNOWN_FOLDER(0x9E52AB10, 0xF80D, 0x49DF, 0xAC, 0xB8, 0x43, 0x30, 0xF5, 0x68, 0x78, 0x55)
FOLDERID_UserProfiles = DEFINE_KNOWN_FOLDER(0x0762D272, 0xC50A, 0x4BB0, 0xA3, 0x82, 0x69, 0x7D, 0xCD, 0x72, 0x9B, 0x80)
FOLDERID_Playlists = DEFINE_KNOWN_FOLDER(0xDE92C1C7, 0x837F, 0x4F69, 0xA3, 0xBB, 0x86, 0xE6, 0x31, 0x20, 0x4A, 0x23)
FOLDERID_SamplePlaylists = DEFINE_KNOWN_FOLDER(
    0x15CA69B3, 0x30EE, 0x49C1, 0xAC, 0xE1, 0x6B, 0x5E, 0xC3, 0x72, 0xAF, 0xB5
)
FOLDERID_SampleMusic = DEFINE_KNOWN_FOLDER(0xB250C668, 0xF57D, 0x4EE1, 0xA6, 0x3C, 0x29, 0x0E, 0xE7, 0xD1, 0xAA, 0x1F)
FOLDERID_SamplePictures = DEFINE_KNOWN_FOLDER(
    0xC4900540, 0x2379, 0x4C75, 0x84, 0x4B, 0x64, 0xE6, 0xFA, 0xF8, 0x71, 0x6B
)
FOLDERID_SampleVideos = DEFINE_KNOWN_FOLDER(0x859EAD94, 0x2E85, 0x48AD, 0xA7, 0x1A, 0x09, 0x69, 0xCB, 0x56, 0xA6, 0xCD)
FOLDERID_PhotoAlbums = DEFINE_KNOWN_FOLDER(0x69D2CF90, 0xFC33, 0x4FB7, 0x9A, 0x0C, 0xEB, 0xB0, 0xF0, 0xFC, 0xB4, 0x3C)
FOLDERID_Public = DEFINE_KNOWN_FOLDER(0xDFDF76A2, 0xC82A, 0x4D63, 0x90, 0x6A, 0x56, 0x44, 0xAC, 0x45, 0x73, 0x85)
FOLDERID_ChangeRemovePrograms = DEFINE_KNOWN_FOLDER(
    0xDF7266AC, 0x9274, 0x4867, 0x8D, 0x55, 0x3B, 0xD6, 0x61, 0xDE, 0x87, 0x2D
)
FOLDERID_AppUpdates = DEFINE_KNOWN_FOLDER(0xA305CE99, 0xF527, 0x492B, 0x8B, 0x1A, 0x7E, 0x76, 0xFA, 0x98, 0xD6, 0xE4)
FOLDERID_AddNewPrograms = DEFINE_KNOWN_FOLDER(
    0xDE61D971, 0x5EBC, 0x4F02, 0xA3, 0xA9, 0x6C, 0x82, 0x89, 0x5E, 0x5C, 0x04
)
FOLDERID_Downloads = DEFINE_KNOWN_FOLDER(0x374DE290, 0x123F, 0x4565, 0x91, 0x64, 0x39, 0xC4, 0x92, 0x5E, 0x46, 0x7B)
FOLDERID_PublicDownloads = DEFINE_KNOWN_FOLDER(
    0x3D644C9B, 0x1FB8, 0x4F30, 0x9B, 0x45, 0xF6, 0x70, 0x23, 0x5F, 0x79, 0xC0
)
FOLDERID_SavedSearches = DEFINE_KNOWN_FOLDER(0x7D1D3A04, 0xDEBB, 0x4115, 0x95, 0xCF, 0x2F, 0x29, 0xDA, 0x29, 0x20, 0xDA)
FOLDERID_QuickLaunch = DEFINE_KNOWN_FOLDER(0x52A4F021, 0x7B75, 0x48A9, 0x9F, 0x6B, 0x4B, 0x87, 0xA2, 0x10, 0xBC, 0x8F)
FOLDERID_Contacts = DEFINE_KNOWN_FOLDER(0x56784854, 0xC6CB, 0x462B, 0x81, 0x69, 0x88, 0xE3, 0x50, 0xAC, 0xB8, 0x82)
FOLDERID_SidebarParts = DEFINE_KNOWN_FOLDER(0xA75D362E, 0x50FC, 0x4FB7, 0xAC, 0x2C, 0xA8, 0xBE, 0xAA, 0x31, 0x44, 0x93)
FOLDERID_SidebarDefaultParts = DEFINE_KNOWN_FOLDER(
    0x7B396E54, 0x9EC5, 0x4300, 0xBE, 0xA, 0x24, 0x82, 0xEB, 0xAE, 0x1A, 0x26
)
FOLDERID_PublicGameTasks = DEFINE_KNOWN_FOLDER(
    0xDEBF2536, 0xE1A8, 0x4C59, 0xB6, 0xA2, 0x41, 0x45, 0x86, 0x47, 0x6A, 0xEA
)
FOLDERID_GameTasks = DEFINE_KNOWN_FOLDER(0x54FAE61, 0x4DD8, 0x4787, 0x80, 0xB6, 0x9, 0x2, 0x20, 0xC4, 0xB7, 0x0)
FOLDERID_SavedGames = DEFINE_KNOWN_FOLDER(0x4C5C32FF, 0xBB9D, 0x43B0, 0xB5, 0xB4, 0x2D, 0x72, 0xE5, 0x4E, 0xAA, 0xA4)
FOLDERID_Games = DEFINE_KNOWN_FOLDER(0xCAC52C1A, 0xB53D, 0x4EDC, 0x92, 0xD7, 0x6B, 0x2E, 0x8A, 0xC1, 0x94, 0x34)
FOLDERID_SEARCH_MAPI = DEFINE_KNOWN_FOLDER(0x98EC0E18, 0x2098, 0x4D44, 0x86, 0x44, 0x66, 0x97, 0x93, 0x15, 0xA2, 0x81)
FOLDERID_SEARCH_CSC = DEFINE_KNOWN_FOLDER(0xEE32E446, 0x31CA, 0x4ABA, 0x81, 0x4F, 0xA5, 0xEB, 0xD2, 0xFD, 0x6D, 0x5E)
FOLDERID_Links = DEFINE_KNOWN_FOLDER(0xBFB9D5E0, 0xC6A9, 0x404C, 0xB2, 0xB2, 0xAE, 0x6D, 0xB6, 0xAF, 0x49, 0x68)
FOLDERID_UsersFiles = DEFINE_KNOWN_FOLDER(0xF3CE0F7C, 0x4901, 0x4ACC, 0x86, 0x48, 0xD5, 0xD4, 0x4B, 0x04, 0xEF, 0x8F)
FOLDERID_UsersLibraries = DEFINE_KNOWN_FOLDER(
    0xA302545D, 0xDEFF, 0x464B, 0xAB, 0xE8, 0x61, 0xC8, 0x64, 0x8D, 0x93, 0x9B
)
FOLDERID_SearchHome = DEFINE_KNOWN_FOLDER(0x190337D1, 0xB8CA, 0x4121, 0xA6, 0x39, 0x6D, 0x47, 0x2D, 0x16, 0x97, 0x2A)
FOLDERID_OriginalImages = DEFINE_KNOWN_FOLDER(
    0x2C36C0AA, 0x5812, 0x4B87, 0xBF, 0xD0, 0x4C, 0xD0, 0xDF, 0xB1, 0x9B, 0x39
)
FOLDERID_DocumentsLibrary = DEFINE_KNOWN_FOLDER(
    0x7B0DB17D, 0x9CD2, 0x4A93, 0x97, 0x33, 0x46, 0xCC, 0x89, 0x02, 0x2E, 0x7C
)
FOLDERID_MusicLibrary = DEFINE_KNOWN_FOLDER(0x2112AB0A, 0xC86A, 0x4FFE, 0xA3, 0x68, 0xD, 0xE9, 0x6E, 0x47, 0x1, 0x2E)
FOLDERID_PicturesLibrary = DEFINE_KNOWN_FOLDER(
    0xA990AE9F, 0xA03B, 0x4E80, 0x94, 0xBC, 0x99, 0x12, 0xD7, 0x50, 0x41, 0x4
)
FOLDERID_VideosLibrary = DEFINE_KNOWN_FOLDER(0x491E922F, 0x5643, 0x4AF4, 0xA7, 0xEB, 0x4E, 0x7A, 0x13, 0x8D, 0x81, 0x74)
FOLDERID_RecordedTVLibrary = DEFINE_KNOWN_FOLDER(
    0x1A6FDBA2, 0xF42D, 0x4358, 0xA7, 0x98, 0xB7, 0x4D, 0x74, 0x59, 0x26, 0xC5
)
FOLDERID_HomeGroup = DEFINE_KNOWN_FOLDER(0x52528A6B, 0xB9E3, 0x4ADD, 0xB6, 0xD, 0x58, 0x8C, 0x2D, 0xBA, 0x84, 0x2D)
FOLDERID_HomeGroupCurrentUser = DEFINE_KNOWN_FOLDER(
    0x9B74B6A3, 0xDFD, 0x4F11, 0x9E, 0x78, 0x5F, 0x78, 0x0, 0xF2, 0xE7, 0x72
)
FOLDERID_DeviceMetadataStore = DEFINE_KNOWN_FOLDER(
    0x5CE4A5E9, 0xE4EB, 0x479D, 0xB8, 0x9F, 0x13, 0x0C, 0x02, 0x88, 0x61, 0x55
)
FOLDERID_Libraries = DEFINE_KNOWN_FOLDER(0x1B3EA5DC, 0xB587, 0x4786, 0xB4, 0xEF, 0xBD, 0x1D, 0xC3, 0x32, 0xAE, 0xAE)
FOLDERID_PublicLibraries = DEFINE_KNOWN_FOLDER(
    0x48DAF80B, 0xE6CF, 0x4F4E, 0xB8, 0x00, 0x0E, 0x69, 0xD8, 0x4E, 0xE3, 0x84
)
FOLDERID_UserPinned = DEFINE_KNOWN_FOLDER(0x9E3995AB, 0x1F9C, 0x4F13, 0xB8, 0x27, 0x48, 0xB2, 0x4B, 0x6C, 0x71, 0x74)
FOLDERID_ImplicitAppShortcuts = DEFINE_KNOWN_FOLDER(
    0xBCB5256F, 0x79F6, 0x4CEE, 0xB7, 0x25, 0xDC, 0x34, 0xE4, 0x2, 0xFD, 0x46
)
FOLDERID_AccountPictures = DEFINE_KNOWN_FOLDER(
    0x008CA0B1, 0x55B4, 0x4C56, 0xB8, 0xA8, 0x4D, 0xE4, 0xB2, 0x99, 0xD3, 0xBE
)
FOLDERID_PublicUserTiles = DEFINE_KNOWN_FOLDER(
    0x0482AF6C, 0x08F1, 0x4C34, 0x8C, 0x90, 0xE1, 0x7E, 0xC9, 0x8B, 0x1E, 0x17
)
FOLDERID_AppsFolder = DEFINE_KNOWN_FOLDER(0x1E87508D, 0x89C2, 0x42F0, 0x8A, 0x7E, 0x64, 0x5A, 0x0F, 0x50, 0xCA, 0x58)
FOLDERID_StartMenuAllPrograms = DEFINE_KNOWN_FOLDER(
    0xF26305EF, 0x6948, 0x40B9, 0xB2, 0x55, 0x81, 0x45, 0x3D, 0x9, 0xC7, 0x85
)
FOLDERID_CommonStartMenuPlaces = DEFINE_KNOWN_FOLDER(
    0xA440879F, 0x87A0, 0x4F7D, 0xB7, 0x0, 0x2, 0x7, 0xB9, 0x66, 0x19, 0x4A
)
FOLDERID_ApplicationShortcuts = DEFINE_KNOWN_FOLDER(
    0xA3918781, 0xE5F2, 0x4890, 0xB3, 0xD9, 0xA7, 0xE5, 0x43, 0x32, 0x32, 0x8C
)
FOLDERID_RoamingTiles = DEFINE_KNOWN_FOLDER(0xBCFC5A, 0xED94, 0x4E48, 0x96, 0xA1, 0x3F, 0x62, 0x17, 0xF2, 0x19, 0x90)
FOLDERID_RoamedTileImages = DEFINE_KNOWN_FOLDER(
    0xAAA8D5A5, 0xF1D6, 0x4259, 0xBA, 0xA8, 0x78, 0xE7, 0xEF, 0x60, 0x83, 0x5E
)
FOLDERID_Screenshots = DEFINE_KNOWN_FOLDER(0xB7BEDE81, 0xDF94, 0x4682, 0xA7, 0xD8, 0x57, 0xA5, 0x26, 0x20, 0xB8, 0x6F)
FOLDERID_CameraRoll = DEFINE_KNOWN_FOLDER(0xAB5FB87B, 0x7CE2, 0x4F83, 0x91, 0x5D, 0x55, 0x8, 0x46, 0xC9, 0x53, 0x7B)
FOLDERID_SkyDrive = DEFINE_KNOWN_FOLDER(0xA52BBA46, 0xE9E1, 0x435F, 0xB3, 0xD9, 0x28, 0xDA, 0xA6, 0x48, 0xC0, 0xF6)
FOLDERID_OneDrive = DEFINE_KNOWN_FOLDER(0xA52BBA46, 0xE9E1, 0x435F, 0xB3, 0xD9, 0x28, 0xDA, 0xA6, 0x48, 0xC0, 0xF6)
FOLDERID_SkyDriveDocuments = DEFINE_KNOWN_FOLDER(
    0x24D89E24, 0x2F19, 0x4534, 0x9D, 0xDE, 0x6A, 0x66, 0x71, 0xFB, 0xB8, 0xFE
)
FOLDERID_SkyDrivePictures = DEFINE_KNOWN_FOLDER(
    0x339719B5, 0x8C47, 0x4894, 0x94, 0xC2, 0xD8, 0xF7, 0x7A, 0xDD, 0x44, 0xA6
)
FOLDERID_SkyDriveMusic = DEFINE_KNOWN_FOLDER(0xC3F2459E, 0x80D6, 0x45DC, 0xBF, 0xEF, 0x1F, 0x76, 0x9F, 0x2B, 0xE7, 0x30)
FOLDERID_SkyDriveCameraRoll = DEFINE_KNOWN_FOLDER(
    0x767E6811, 0x49CB, 0x4273, 0x87, 0xC2, 0x20, 0xF3, 0x55, 0xE1, 0x08, 0x5B
)
FOLDERID_SearchHistory = DEFINE_KNOWN_FOLDER(0x0D4C3DB6, 0x03A3, 0x462F, 0xA0, 0xE6, 0x08, 0x92, 0x4C, 0x41, 0xB5, 0xD4)
FOLDERID_SearchTemplates = DEFINE_KNOWN_FOLDER(
    0x7E636BFE, 0xDFA9, 0x4D5E, 0xB4, 0x56, 0xD7, 0xB3, 0x98, 0x51, 0xD8, 0xA9
)
FOLDERID_CameraRollLibrary = DEFINE_KNOWN_FOLDER(
    0x2B20DF75, 0x1EDA, 0x4039, 0x80, 0x97, 0x38, 0x79, 0x82, 0x27, 0xD5, 0xB7
)
FOLDERID_SavedPictures = DEFINE_KNOWN_FOLDER(0x3B193882, 0xD3AD, 0x4EAB, 0x96, 0x5A, 0x69, 0x82, 0x9D, 0x1F, 0xB5, 0x9F)
FOLDERID_SavedPicturesLibrary = DEFINE_KNOWN_FOLDER(
    0xE25B5812, 0xBE88, 0x4BD9, 0x94, 0xB0, 0x29, 0x23, 0x34, 0x77, 0xB6, 0xC3
)
FOLDERID_RetailDemo = DEFINE_KNOWN_FOLDER(0x12D4C69E, 0x24AD, 0x4923, 0xBE, 0x19, 0x31, 0x32, 0x1C, 0x43, 0xA7, 0x67)
FOLDERID_Device = DEFINE_KNOWN_FOLDER(0x1C2AC1DC, 0x4358, 0x4B6C, 0x97, 0x33, 0xAF, 0x21, 0x15, 0x65, 0x76, 0xF0)
FOLDERID_DevelopmentFiles = DEFINE_KNOWN_FOLDER(
    0xDBE8E08E, 0x3053, 0x4BBC, 0xB1, 0x83, 0x2A, 0x7B, 0x2B, 0x19, 0x1E, 0x59
)
FOLDERID_Objects3D = DEFINE_KNOWN_FOLDER(0x31C0DD25, 0x9439, 0x4F12, 0xBF, 0x41, 0x7F, 0xF4, 0xED, 0xA3, 0x87, 0x22)
FOLDERID_AppCaptures = DEFINE_KNOWN_FOLDER(0xEDC0FE71, 0x98D8, 0x4F4A, 0xB9, 0x20, 0xC8, 0xDC, 0x13, 0x3C, 0xB1, 0x65)
FOLDERID_LocalDocuments = DEFINE_KNOWN_FOLDER(
    0xF42EE2D3, 0x909F, 0x4907, 0x88, 0x71, 0x4C, 0x22, 0xFC, 0x0B, 0xF7, 0x56
)
FOLDERID_LocalPictures = DEFINE_KNOWN_FOLDER(0x0DDD015D, 0xB06C, 0x45D5, 0x8C, 0x4C, 0xF5, 0x97, 0x13, 0x85, 0x46, 0x39)
FOLDERID_LocalVideos = DEFINE_KNOWN_FOLDER(0x35286A68, 0x3C57, 0x41A1, 0xBB, 0xB1, 0x0E, 0xAE, 0x73, 0xD7, 0x6C, 0x95)
FOLDERID_LocalMusic = DEFINE_KNOWN_FOLDER(0xA0C69A99, 0x21C8, 0x4671, 0x87, 0x03, 0x79, 0x34, 0x16, 0x2F, 0xCF, 0x1D)
FOLDERID_LocalDownloads = DEFINE_KNOWN_FOLDER(
    0x7D83EE9B, 0x2244, 0x4E70, 0xB1, 0xF5, 0x53, 0x93, 0x04, 0x2A, 0xF1, 0xE4
)
FOLDERID_RecordedCalls = DEFINE_KNOWN_FOLDER(0x2F8B40C2, 0x83ED, 0x48EE, 0xB3, 0x83, 0xA1, 0xF1, 0x57, 0xEC, 0x6F, 0x9A)
FOLDERID_AllAppMods = DEFINE_KNOWN_FOLDER(0x7AD67899, 0x66AF, 0x43BA, 0x91, 0x56, 0x6A, 0xAD, 0x42, 0xE6, 0xC5, 0x96)
FOLDERID_CurrentAppMods = DEFINE_KNOWN_FOLDER(
    0x3DB40B20, 0x2A30, 0x4DBE, 0x91, 0x7E, 0x77, 0x1D, 0xD2, 0x1D, 0xD0, 0x99
)
FOLDERID_AppDataDesktop = DEFINE_KNOWN_FOLDER(
    0xB2C5E279, 0x7ADD, 0x439F, 0xB2, 0x8C, 0xC4, 0x1F, 0xE1, 0xBB, 0xF6, 0x72
)
FOLDERID_AppDataDocuments = DEFINE_KNOWN_FOLDER(
    0x7BE16610, 0x1F7F, 0x44AC, 0xBF, 0xF0, 0x83, 0xE1, 0x5F, 0x2F, 0xFC, 0xA1
)
FOLDERID_AppDataFavorites = DEFINE_KNOWN_FOLDER(
    0x7CFBEFBC, 0xDE1F, 0x45AA, 0xB8, 0x43, 0xA5, 0x42, 0xAC, 0x53, 0x6C, 0xC9
)
FOLDERID_AppDataProgramData = DEFINE_KNOWN_FOLDER(
    0x559D40A3, 0xA036, 0x40FA, 0xAF, 0x61, 0x84, 0xCB, 0x43, 0xA, 0x4D, 0x34
)
