from ctypes import POINTER, Structure
from ctypes.wintypes import BYTE, USHORT

from ..shared.guiddef import GUID

KNOWNFOLDERID = GUID
REFKNOWNFOLDERID = POINTER(KNOWNFOLDERID)


class SHITEMID(Structure):
    _pack_ = 1
    _fields_ = [
        ("cb", USHORT),
        ("abID", BYTE),  # abID[ 1 ]
    ]


LPSHITEMID = POINTER(SHITEMID)


class ITEMIDLIST(Structure):
    _pack_ = 1
    _fields_ = [
        ("mkid", SHITEMID),
    ]


ITEMIDLIST_RELATIVE = ITEMIDLIST
ITEMID_CHILD = ITEMIDLIST
ITEMIDLIST_ABSOLUTE = ITEMIDLIST

LPITEMIDLIST = POINTER(ITEMIDLIST)
LPCITEMIDLIST = POINTER(ITEMIDLIST)
PIDLIST_ABSOLUTE = POINTER(ITEMIDLIST_ABSOLUTE)
PCIDLIST_ABSOLUTE = POINTER(ITEMIDLIST_ABSOLUTE)
PCUIDLIST_ABSOLUTE = POINTER(ITEMIDLIST_ABSOLUTE)
PIDLIST_RELATIVE = POINTER(ITEMIDLIST_RELATIVE)
PCIDLIST_RELATIVE = POINTER(ITEMIDLIST_RELATIVE)
PUIDLIST_RELATIVE = POINTER(ITEMIDLIST_RELATIVE)
PCUIDLIST_RELATIVE = POINTER(ITEMIDLIST_RELATIVE)
PITEMID_CHILD = POINTER(ITEMID_CHILD)
PCITEMID_CHILD = POINTER(ITEMID_CHILD)
PUITEMID_CHILD = POINTER(ITEMID_CHILD)
PCUITEMID_CHILD = POINTER(ITEMID_CHILD)
PCUITEMID_CHILD_ARRAY = POINTER(PCUITEMID_CHILD)
PCUIDLIST_RELATIVE_ARRAY = POINTER(PCUIDLIST_RELATIVE)
PCIDLIST_ABSOLUTE_ARRAY = POINTER(PCIDLIST_ABSOLUTE)
PCUIDLIST_ABSOLUTE_ARRAY = POINTER(PCUIDLIST_ABSOLUTE)
